"""
Tool Name: EXPLORING ARCPY
Source Name: script.py
Version: 0.1
Author: Giovanni Zambotti (gzambotti@cga.harvard.edu, g.zambotti@gmail.com)
Date: 09/12/2012
Purpose: learning pyhton
License: free to use
"""
# import basic module
import sys, os

# Import arcpy module
import arcpy
# import enviromental 
from arcpy import env

# this required to import module os, and sys
PATHNAME = os.path.dirname(sys.argv[0])
env.workspace = PATHNAME + r"\demo.gdb"
print " -------------------------------------------------------------------------------------- "
print "WORKSPACE: " + env.workspace
print " -------------------------------------------------------------------------------------- "


# set the workspace
#env.workspace = r"C:\gis\2012\2012_ModelBuilder_Class_GZ\model\data\results.gdb"
# Set overwrite option
arcpy.env.overwriteOutput = True

try:
    """
    
    ######################################################################
    # Example 1                                                          #
    # print on screen the list of feature classes inside the result gdb  #
    ######################################################################
    
    print "List of Feature Classes: "
    fc = arcpy.ListFeatureClasses("")
    for features in fc :
        print features

    """
    #######################################################################
    # Example 2                                                           #   
    # create a feature class based on a simple query                      #
    #######################################################################
    """
    fc_province_in = "gha_adm2.shp"
    fc_province_lyr = "lyr"
    
    arcpy.MakeFeatureLayer_management(fc_province_in, fc_province_lyr)
    
    query = "\"NAME_2\" = \'Accra'"
    
    arcpy.SelectLayerByAttribute_management(fc_province_lyr, "NEW_SELECTION", query)
    print query    

    arcpy.CopyFeatures_management(fc_province_lyr, "foo_new")
    
    """
    
    ##############################################################################
    # Example 3                                                                  #  
    # select a specific provinces and create a serious of buffer layer around it.#
    ##############################################################################    
    """
    provinceName = ['Accra','Akwapim North','Kwabibirem']
    bufferDis = [1000, 2000, 3000]
    inFeature = "gha_adm2.shp"
    
    # define a new layer and make a Feature Layer with it
    inLyr = "lyr"
    arcpy.MakeFeatureLayer_management(inFeature, inLyr)
    
    
    for a in provinceName:
        
        q = "\"NAME_2\" = \'" + "".join(map(str,a)) + "\'"
        print q
        #outFeature = str("".join(map(str,a))) + ".shp"
        outFeature = str("".join(map(str,a)))
        outFeatureClean = outFeature.replace(" ", "_")
        arcpy.SelectLayerByAttribute_management(inLyr, "NEW_SELECTION", q)
        arcpy.CopyFeatures_management(inLyr, outFeatureClean)
         
        for buf in bufferDis:
            outFeatureCleanBuffer = outFeatureClean + "_" + str(buf)
            bufferSet = str(buf) + " Meters"
            arcpy.Buffer_analysis(outFeatureClean, outFeatureCleanBuffer, bufferSet, "FULL", "ROUND", "", "")
    """        
        
except:
    print arcpy.GetMessages()
